/* eslint-disable react/no-unstable-nested-components */
import { createColumnHelper } from '@tanstack/react-table';
import { useRouter } from 'next/router';
import { useCallback, useMemo } from 'react';

import { Property, useCategoryDetail, usePropertiesMeta } from '@api/catalog';

import Table, { useSorting, useTable } from '@components/Table';
import { getSettingsColumn } from '@components/Table/columns';
import { Cell, TableEmpty, TableHeader } from '@components/Table/components';

import { CREATE_PARAM } from '@scripts/constants';
import { scale, typography } from '@scripts/gds';
import { declOfNum } from '@scripts/helpers';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';

export default function InheritedPropertiesTable() {
    const { query } = useRouter();
    const id = Array.isArray(query.pid) ? query.pid[0] : query.pid;
    const isCreatePage = id === CREATE_PARAM;

    const { data: category } = useCategoryDetail(Number(id), !!id && !isCreatePage);
    const categoryData = useMemo(() => category?.data, [category]);

    const { data: meta } = usePropertiesMeta();
    const metaData = useMemo(() => meta?.data, [meta]);

    const { metaField } = useAutoFilters(metaData);

    const pageKey = 'product-properties-inherited';

    const [{ sorting }, sortingPlugin] = useSorting<Property>(pageKey, metaData?.fields, undefined, false);

    const dataToEnrich = useMemo(
        () => [...(categoryData?.properties?.filter(item => item.is_inherited) || [])],
        [categoryData]
    );

    const propertiesTableData = useAutoTableData<Property>(dataToEnrich, metaField);

    const tableData = useMemo(
        () =>
            (propertiesTableData || []).map(item => ({
                ...item,
                id: item?.property_id,
                customListLink: '/products/directories/properties',
            })),
        [propertiesTableData]
    );

    const autoGeneratedColumns = useAutoColumns(metaData);

    const columnHelper = createColumnHelper<Property>();

    const columns = useMemo(
        () => [
            ...autoGeneratedColumns.filter(item => !['created_at', 'updated_at'].includes(String(item?.accessorKey))),

            columnHelper.accessor('is_required', {
                header: 'Обязательный',
                cell: ({ getValue }) => <Cell value={getValue()} type="bool" />,
            }),

            columnHelper.accessor('is_gluing', {
                header: 'Параметр склеивания',
                cell: ({ getValue }) => <Cell value={getValue()} type="bool" />,
            }),
            getSettingsColumn({ columnsToDisable: [], visibleColumns: metaData?.default_list, hasCell: false }),
        ],
        [autoGeneratedColumns, metaData?.default_list]
    );

    const renderHeader = useCallback(
        () => (
            <TableHeader>
                <div
                    css={{
                        display: 'flex',
                        justifyContent: 'space-between',
                        width: '100%',
                        padding: `0 ${scale(3)}px`,
                    }}
                >
                    <p css={{ lineHeight: '32px', ...typography('bodySm') }}>
                        {`${tableData?.length} ${declOfNum(Number(tableData?.length), [
                            'атрибут',
                            'атрибута',
                            'атрибутов',
                        ])}`}
                    </p>
                </div>
            </TableHeader>
        ),
        [tableData]
    );

    const table = useTable(
        {
            data: tableData,
            columns,
            meta: {
                tableKey: pageKey,
            },
            state: {
                sorting,
            },
        },
        [sortingPlugin]
    );

    return (
        <>
            {propertiesTableData?.length > 0 ? (
                <>
                    {renderHeader()}
                    <Table instance={table} />
                </>
            ) : null}
            {propertiesTableData?.length === 0 ? (
                <TableEmpty
                    filtersActive={false}
                    titleWithFilters="Наследуемых атрибутов не найдено"
                    titleWithoutFilters="Наследуемых атрибутов нет"
                />
            ) : null}
        </>
    );
}
